﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Xml.Linq;

namespace NetflixPhoneApp
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            WebClient wc = new WebClient();

            wc.DownloadStringCompleted += new DownloadStringCompletedEventHandler(wc_DownloadStringCompleted);
            string query = string.Format("http://odata.netflix.com/catalog/Titles()?$filter=substringof('{0}',Name)&$orderby=Name&$top=15", textBox1.Text);
            wc.DownloadStringAsync(new Uri(query));

        }

        void wc_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            if (e.Error != null)
            {
                MessageBox.Show(e.Error.ToString());
                return;
            }

            XNamespace ns = "http://www.w3.org/2005/Atom";
            XNamespace od = "http://schemas.microsoft.com/ado/2007/08/dataservices";
            XNamespace meta = "http://schemas.microsoft.com/ado/2007/08/dataservices/metadata";

            // process the results...
            XElement xml = XElement.Parse(e.Result);

            var Titles = from x in xml.Descendants(ns + "entry")
                         let prop = x.Element(meta + "properties")
                         select new Movie
                        {
                            BoxArt = prop.Element(od + "BoxArt").Element(od+"LargeUrl").Value,
                            Name = prop.Element(od + "ShortName").Value,
                            ReleaseYear = prop.Element(od + "ReleaseYear").Value,
                            ShortSynopsis = prop.Element(od + "ShortSynopsis").Value
                        };
            listBox1.ItemsSource = Titles;
        }

    }
}