﻿using System;
using System.Collections.Generic;
using System.Data.Services;
using System.Data.Services.Common;
using System.Linq;
using System.ServiceModel.Web;
using System.Web;

namespace SLGroups.Web
{
    public class GroupData : DataService< DemoDBEntities>
    {
        // This method is called only once to initialize service-wide policies.
        public static void InitializeService(DataServiceConfiguration config)
        {
            config.SetEntitySetAccessRule("*", EntitySetRights.All);
            config.SetServiceOperationAccessRule("*", ServiceOperationRights.All);

            // TODO: set rules to indicate which entity sets and service operations are visible, updatable, etc.
            // Examples:
            // config.SetEntitySetAccessRule("MyEntityset", EntitySetRights.AllRead);
            // config.SetServiceOperationAccessRule("MyServiceOperation", ServiceOperationRights.All);
            config.DataServiceBehavior.MaxProtocolVersion = DataServiceProtocolVersion.V2;
        }

        [WebGet]
        public List<string> SayHello(string sIn)
        {
            return new List<string>() { "Hello HDC", sIn };
        }

        [WebGet]
        public IQueryable<GetGroupsByZip_Result> GetGroupsByZip(string sZip)
        {
            IQueryable<GetGroupsByZip_Result> query =
                this.CurrentDataSource.GetGroupsByZip(sZip, 15, null).AsQueryable();
            return query;
        }
        [WebGet]
        public IQueryable<GetGroupsByRect_Result> GetGroupsByRect(string tlLat, string tlLong, string brLat, string brLong)
        {
            IQueryable<GetGroupsByRect_Result> query =
                this.CurrentDataSource.GetGroupsByRect(decimal.Parse(tlLat), decimal.Parse(tlLong), decimal.Parse(brLat), decimal.Parse(brLong)).AsQueryable();
            return query;
        }    
    }
}
